import { EventEmitter, OnInit, ElementRef } from '@angular/core';
import { ControlValueAccessor, Validator, AbstractControl, ValidationErrors } from '@angular/forms';
import { HacDatepickerOptions } from './hac.datepicker.options';
import { HacCalendarModel, HacCalendarDayModel, WeekDay } from '../models/hac.calendar.model';
export declare class HacDatepickerComponent implements OnInit, ControlValueAccessor, Validator {
    private elementRef;
    private _startDate;
    startDate: Date | string;
    private _endDate;
    endDate: Date | string;
    startDateChange: EventEmitter<string | Date>;
    endDateChange: EventEmitter<string | Date>;
    selected: Date | string;
    readonly selectedChange: EventEmitter<Date | string>;
    private _options;
    options: HacDatepickerOptions;
    disabled: boolean;
    calendars: HacCalendarModel[];
    weekDayList: WeekDay[];
    private _collapsed;
    collapsed: boolean;
    private forcedSelectionKind?;
    private hoverDate?;
    constructor(elementRef: ElementRef);
    ngOnInit(): void;
    onClick(event: any): void;
    buildCalendarModel(): void;
    select(day: HacCalendarDayModel): void;
    isSelected(day: HacCalendarDayModel): boolean;
    isDisabled(day: HacCalendarDayModel, selectionKind?: SelectionKind): boolean;
    isStart(day: HacCalendarDayModel): boolean;
    isEnd(day: HacCalendarDayModel): boolean;
    inRange(day: HacCalendarDayModel, useHover?: boolean): boolean;
    setHoverDate(day: HacCalendarDayModel): void;
    clearDates(): void;
    prevMonth($event?: Event): void;
    nextMonth($event?: Event): void;
    toggleCalendar(event: any): void;
    getSelectionKind(): SelectionKind;
    forceSelectionKind(kind?: SelectionKind): void;
    selectToday(): void;
    isTodayActionEnabled(): boolean;
    isClearActionEnabled(): boolean;
    getSelectorElem(): HTMLElement;
    isPrevArrowVisible(calendarIndex: number): boolean;
    isNextArrowVisible(calendarIndex: number): boolean;
    focus(): void;
    focusout(): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    validate(c: AbstractControl): ValidationErrors | null;
    registerOnValidatorChange?(fn: () => void): void;
    private pushNewModelChange();
    private onTouchedCallback;
    private onChangeCallback;
    private onValidatorChangeCallback;
    private setOptionsDefaults();
    private setStartDate(day?);
    private setEndDate(day?);
    private getLastRangeDay();
    private isInDayList(day, selectionKind?);
    private animate();
    private getMinDate();
    private getMaxDate();
    private emitFocusEvent();
}
export declare type SelectionKind = 'start' | 'end';
