import { EventEmitter, ElementRef, OnDestroy } from '@angular/core';
import { HacDropdownOption, HacDropdownOptionGroup } from '../models';
import { HacDropdownFilterPipe } from '../pipes/hac.dropdown.filter';
import { ControlValueAccessor } from '@angular/forms';
export declare class HacDropdownComponent implements OnDestroy, ControlValueAccessor {
    private elementRef;
    private dropdownFilter;
    optionGroups: HacDropdownOptionGroup[];
    placeholder: string;
    allowEmpty: boolean;
    filtrable: boolean;
    selectedChange: EventEmitter<{}>;
    id: string;
    disabled: boolean;
    private _selected;
    selected: string | number;
    collapsed: boolean;
    filter: string;
    private subscriptions;
    private windowHeight;
    constructor(elementRef: ElementRef, dropdownFilter: HacDropdownFilterPipe);
    ngOnDestroy(): void;
    onClick(event: MouseEvent): void;
    onResize(event: any): void;
    onScroll(event: any): void;
    getSelected(): HacDropdownOption;
    select(key: number | string): void;
    hasGroups(): boolean;
    openDropdown(e?: any): void;
    closeDropdown(e?: any): void;
    toggleDropdown(e?: any): void;
    shouldApplyFilter(): boolean;
    handleKey(e: KeyboardEvent): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    private onTouchedCallback;
    private onChangeCallback;
    getFilterElem(): HTMLElement;
    calcDropdownHeight(): string;
    private findOptionByKey(key);
    private updateFilter();
    private syncWindowHeight();
    private getPos(el);
    private blurFilter();
    private selectFirstMatchingOption();
}
